Changes from version 8.3.13 to 8.3.14
=====================================
NEW:     New conversion type "Unprotected Binary" for Lower Silesian Turbo 2000
         introduced. This conversion type can convert binary files with
         INIT segments.
         
         A binary loader has been developed for this purpose. It has been
         added to the loader package "loaders_1.3".
         
NEW:     First version of Tape Image Extractor tool introduced.
         This tool allows data extraction from tape images.
         
UPDATE:  Lower Silesian Turbo 2000 description updated in the documentation.         

Changes from version 8.3.12 to 8.3.13
=====================================
NEW:     Initial support for Lower Silesian Turbo 2000. 
         Conversion of binary files to the Auto Turbo format is supported.
         Wizard for binary files updated accordingly
         
UPDATE:  Documentation Updated. Atari Super Turbo (AST) partial documentation
         added. Partial Lower Silesian Turbo 2000 documentation added.

UPDATE:  Playlist item dialog remembers plugin that has been
         used during prior execution of Turgen System.
         
ARCHIT:  Plugins use more efficient instruction buffering.


Changes from version 8.3.11 to 8.3.12
=====================================
NEW:     Standard plugin can convert segmented binary files.
         Binary loader "stdbload" has been created for this purpose.
         Loader package has been updated.

NEW:     Double-buffered direct audio output.
         Direct audio output is now double buffered. This reduces
         number of round-trips between TS and operating system's native
         sound facilities. CPU usage has been reduced significantly
         on a system with PulseAudio.

Changes from version 8.3.10 to 8.3.11
=====================================
NEW:     Turbo 2000, Super Turbo, Turbo 2000 - kilobyte blocks, and
         B-TAPE plugins now allow to prepend Universal Turbo loader
         as a standard cassette boot file. This is for users who
         do not have a cartridge with a loader.
         
NEW:     Standard tape records can be generated without modulation.
         This should allow to load standard tape records also when
         devices like MEGA-CD interface are used.
         
UPDATE:  The Wizzard for binary files supports Standard tape records.


Changes from version 8.3.9 to 8.3.10
====================================
UPDATE:  Cassette boot files created by the Standard plugin have smarter
         (and longer) initialization routine. These boot files now never
         overlap with OS ROM.

Changes from version 8.3.8 to 8.3.9
====================================
NEW:     Standard plugin introduced. It can convert the following input files
         to standard tape records: Monolithic binary files, tokenized BASIC files, 
         BASIC source files, and plain data files.

UPDATE:  Wave generator and direct audio generator allow to output signal only
         to the right channel. This can be set using the program configuration facility.
         
UPDATE:  Amplitude setting is honored also for standard tape records

UPDATE:  Tape image plugin is now registered in the plugins.list file like other
         plugins. This allows to change position of this plugin in the "Plugin" box
         of the "Playlist item" dialog.
         
UPDATE:  Tape image plugin is using its own separate pair of file choosers for input and
         output files. This provides convenience because tape images are usually stored
         separately.

Changes from version 8.3.7 to 8.3.8
===================================
UPDATE:  Tape image plugin supports "fsk " chunks on input
UPDATE:  FUJI chunk data is passed through when generating tape images


Changes from version 8.3.6 to 8.3.7
===================================
NEW:     Rudimentary support for standard (FSK) tape records introduced.
         Tape image plugin now supports "baud" and dependent "data" chunks on input, so
         TURGEN SYSTEM can be used as a comfortable CAS2WAV convertor.
         There is no support for "fsk" chunks yet.
         
         NOTE: Despite optimizations, the FSK generator is a very resource demanding
         module. It is not recommended to use direct audio output when processing
         standard tape records. 
         

Changes from version 8.3.5 to 8.3.6
===================================
NEW:     New binary loader HTBL+ for Hard Turbo from Poland with
         the following enhancements
        
         1. Data recorder motor is switched off after segment data is loaded. This
            enables loading of binary files that execute lot of code from INIT
            segments.
         2. RUNAD is set in a way that allows RUN segment to be the first segment
            of the binary file.
         3. The loader never waits for any key under normal circumstances. This
            makes the loader easier to use with devices that do not support MOTOR CTRL
            signal
         4. The loader forces warm start during its initialization. This allows to load and run
            programs that rely on the display configuration set up by the
            warm start routines ("blue screen")
         5. BASIC is automatically disabled
        
UPDATE:  Turbo loaders package updated to version 1.1
         - Added new HTBL+ loader source code
         - Binaries are available for a subset of loaders
        
UPDATE:  Tool for embedding of tokenized ATARI BASIC files to
         binary files detects more error conditions and
         provides more polished error messages.
        
REMOVED: csturbo2000_loadergenerator.cas tape image removed, because
         it is not an open source software and it is not
         appropriate to distribute it on SF.


Changes from version 8.3.4 to 8.3.5
===================================
NEW:    Turbo generator supports Hard Turbo from Poland.

BUGFIX: BUG DESCRIPTION:
        Turbo decoder may incorrectly process WAVE files that contain
        chunks other than "RIFF", "WAVE", "fmt ", and "data".
                                                                                                        
        SYMPTOMS:
        Sample numbers in messages issued by the turbo decoder can be wrong.
        Turbo decoder may decode data out of the data chunk.
        Data format may not be recognized.
        Incorrect WAVE file length in samples is reported.   
         
        CIRCUMVENTION:
        Process only simple WAVE files that have just "RIFF", "WAVE", "fmt ",
        and "data" chunk.
        
        FIX:
        WAVE file processing code updated to skip unknown chunks.
        
        NOTES:
        Bug found when processing WAVE files with "bext" chunks 
        created using Adobe Audition.
        
NEW:    TURGEN SYSTEM is now distributed in two separate packages
        1. Binary package that contains only files required to run TS, 
           documentation, and licence
        2. Source package that contains source code, documentation sources,
           distribution scripts, and the licence
           
UPDATE: System requirements have changed. Now Java Runtim Environment 1.5.0
        is required.

Changes from version 8.3.3 to 8.3.4
===================================
UPDATE: Tool that embeds tokenized BASIC files can protect the BASIC program
        against listing by disabling the BREAK key and setting the COLDST flag.

UPDATE: Turbo ROM decoder can decode BASIC files.    

Changes from version 8.3.2 to 8.3.3
===================================
NEW:    Tool that embeds tokenized BASIC files to monolithic binary files has been
        added. Some turbo systems can accommodate binary files only, this tool
        helps to circumvent such limitation.

BUGFIX: BUG DESCRIPTION:
        A race condition may occur when something wrong goes with restoring of the user
        interface persistence data from the winlayout.ser file.
        
        SYMPTOMS:
        Turgen System freezes during start up before the main window is shown.
        
        CIRCUMVENTION:
        Start Turgen System multiple times until it starts up.
        
        FIX:
        User interface is updated from the AWT thread when necessary.


Changes from version 8.3.1 to 8.3.2
===================================
NEW:    Turbo decoder supports polish Turbo ROM (binary files only)
NEW:    Turbo ROM plugin can convert also BASIC files
NEW:    Turbo decoder supports polish Atari Super Turbo

Changes from version 8.3.0 to 8.3.1
===================================
UPDATE  Universal Turbo decoder replaces older Super Turbo decoder. This new
        decoder can decode both Turbo 2000 and Super Turbo files. Turbo system
        is recognized automatically.
BUGFIX: Adaptive transfer speed detection for Turbo Blizzard decoder now
        works with all sample rates and not only with 44100 Hz.

Changes from version 8.2.17 to 8.3.0
=====================================
NEW:    Turbo decoder supports Polish Turbo Blizzard
UPDATE: Turbo decoder GUI reworked
UPDATE: Turbo decoder settings radically simplified, all functionality has been preserved.
UPDATE: Turbo monitor can decode raw blocks of all turbo systems supported by the decoder.
BUGFIX: KSO Turbo 2000 decoder required certain polarity of pulses
BUGFIX: Super Turbo decoder was using only first 10 characters of file name

Changes from version 8.2.16 to 8.2.17
=====================================
NEW:    Turbo decoder supports sample rates from 44100 to 96000 Hz.
UPDATE: Turbo decoder GUI updated to reflect new capabilities.
NEW:    Turbo decoder decodes Polish KSO Turbo 2000.
REMOVED:Settings for Turbo 2000 block decoder removed.
INCOMP: UI persistence settings from previous versions will be lost.

Changes from version 8.2.15 to 8.2.16
=====================================
NEW:    Turbo decoder supports 16-bit samples in WAVE files.
BUGFIX: trXX tape image chunks no longer have always baud rate of 1.
UPDATE: B-TAPE plugin can be forced to output tr2k tape image chunks
        instead of trbt chunks.

Changes from version 8.2.14 to 8.2.15
=====================================
UPDATE: Minor GUI changes (Components don't shake when windows are resized)
UPDATE: More settings for Turbo ROM
UPDATE: UI persistence system update
INCOMP: UI persistence settings from previous versions will be lost
REMOVED: Splash screen removed
BUGFIX: Fixed possible race condition when updating look and feel

Changes from version 8.2.13 to 8.2.14
=====================================
BUGFIX: Fixed NullPointerException when loading header from external file
UPDATE: Minor GUI changes.

Changes from version 8.2.12 to 8.2.13
=====================================
UPDATE: Several dialogs provided with mnemonics
NEW:    Turbo decoder can save Turbo 2000 or Super Turbo header to 
        a separate file.
NEW:    Turbo 2000 and Super Turbo plugins can load turbo header
        from external file.

Changes from version 8.2.11 to 8.2.12
=====================================
UPDATE:  Turbo decoder supports stereo WAVE files
UPDATE:  Turbo decoder is more verbose
UPDATE:  Turbo decoder GUI minor refit
UPDATE:  Decoding from WAVE files is much faster due to buffering

Changes from version 8.2.10 to 8.2.11
=====================================
UPDATE:  Tape images with pwmX chunks (used by A8CAS) are supported on input
BUGFIX:  Fixed NullPointerException when a generator is cancelled multiple times
REMOVED: Sampling rate of 22050 Hz removed as an obsolete feature
UPDATE:  Wizard for binary files can display file information dialog
REMOVED: IntroFrame removed. Program directory detection is just fine.

Changes from version 8.2.9 to 8.2.10
====================================
UPDATE:  Miniature binary loaders updated. Now they emulate successfull boot
         from a floppy disk (BOOT? is set and COLDST flag is reset). This helps
         to load binary files that rely on these flags.
UPDATE:  Turbo decoder prepends sample number to the output files. This is
         now optional (except Turbo Monitor).

Changes from version 8.2.8 to 8.2.9
===================================
BUGFIX:  Fixed mangled messages issued by the Turbo monitor decoder
UPDATE:  Tape image output synchronized with A8CAS project updates.
         The pwmi chunk now becomes pwml chunk.

Changes from version 8.2.7 to 8.2.8
===================================
UPDATE:  More settings for Atari Super Turbo.

Changes from version 8.2.6 to 8.2.7
===================================
NEW:     Initial polish Atari Super Turbo support. Conversion of binary file to
         the AST and BUT formats is possible. Generic BUT loader was developed.
UPDATE:  Minor GUI refit

Changes from version 8.2.5 to 8.2.6
====================================
BUGFIX:  Turbo decoder's support for direct audio input works also under Microsoft Windows. The
         signal retrieval loop has been reworked.
NEW:     Wizard for binary files offers by default conversion methods that require only
         generally available loaders, so inexperienced users are not confused by unloadable
         files.
NEW:     Turbo decoder supports decoding of stereo audio input. Left, right or ono channel
         can be selected.

Changes from version 8.2.4 to 8.2.5
===================================
BUGFIX:  Once the AudioPulseDecoder was stopped, it had also to be detached to be able to
         decode the signal again.
NEW:     Added emergency stop possibility to the AudioPulseDecoder to handle bad audio
         system setup.

Changes from version 8.2.3 to 8.2.4
===================================
NEW:     Turbo decoder supports direct audio input
UPDATE:  Turbo decoder frame has more persistent elements

Changes from version 8.2.2 to 8.2.3
===================================
BUGFIX:  trXX chunks are written correctly to the tape images
UPDATE:  Minor UI updates (Unified insets of components in the Playlist item dialog)

Changes from version 8.2.1 to 8.2.2
===================================
NEW:     Turbo ROM limited support (conversion if binary files only)
NEW:     STOP pulse support. Bit order LSB>MSB support (because of Turbo ROM)
UPDATE:  Minor improvement of AudioGenerator and WaveGenerator performance (INSTR_DATA) instruction
UPDATE:  Minor code cleanups


Changes from version 8.2.0 to 8.2.1
===================================
UPDATE:  Program logs to turgen.log file instead of console.txt.
BUGFIX:  Correct pulses for KSO Turbo 2000
UPDATE:  Related documentation portions fixed and synced
UPDATE:  Various documentation fixes

Changes from version 8.1.4 to 8.2.0
===================================

UPDATE:  Look and Feel change is easier
UPDATE:  Documentation translation updated
UPDATE:  Panel with main control buttons refit
UPDATE:  Various fixes and improvements
BUGFIX:  Plugins generate tape image from tape image without
         any redundant trXX and pwms chunks
UPDATE:  TapeImagePlugin is now built-in
UPDATE:  Tape image parser reworked. Tape image chunks are
         now represented in completely different way
UPDATE:  Silence generation has now granularity 0.1 seconds
UPDATE:  Configuration entries rearranged
UPDATE:  Silence generation after INIT segment simplified and
         now supported by Turbo Blizzard and KSO Turbo 2000
         plugins. This is useful when MOTOR CTRL signal is
         not supported (various XC-12 replacements)
UPDATE:  "Check loader" button now checks number of segments
         of the binary file if needed
UPDATE:  Turbo 2000 - kilobyte blocks, B-TAPE, KSO Turbo 2000
         and Turbo blizzard plugins now process input files
         in more similar way using readFully() method.
UPDATE:  GTKLookAndFeel now does not screw main menubar
UPDATE:  Optimized handling of silence when creating
         tape images with pwmX chunks. Silence 
         only pwmi chunks are avoided if possible
UPDATE:  UI settings persistence refactored. Wizard
         remembers data recorder modification.
         Postprocessing setting is now remembered.
UPDATE:  Information about pulses is now held in one
         plain text file. Preliminary support for
         STOP type pulse.
UPDATE:  Minor GUI refit
UPDATE:  Tape image plugin initializes like other plugins, there
         is no chunk registration process anymore.
UPDATE:  Wizard for binary files updated to handle polish
         turbo modifications. They don't have too much sense,
         but upcoming AST and Turbo ROM will bring the sense
         right back.
UPDATE:  New binary convertors for the wizard without loaders.
BUGFIX:  Some binary convertors calculated number of pilot
         tones badly.
INCOMP:  plugins.properties renamed to to plugins.list, because in
         fact it is not java.util.Properties file
NEW:     Support for pwm chunks in tape images (output only).
         Use Tools>Preferences
         Tape image generator > Tape image chunks > pwmX
UPDATE:  Configuration system made more user friendly, because
         all configuration settings use human readable names
UPDATE:  Refit of turbo decoder messages. Fixed file name
         construction which now better reflects position
         in the wave file.
UPDATE:  Look and feel change routine improved. Now it
         remembers last look and feel in order to not
         change to same look and feel. Blank look and
         feel is now a synonym for Metal look and feel
UPDATE:  File statistics dialog improved
UPDATE:  Turbo decoder output file name construction improved
UPDATE:  Turbo monitor can save all decoded bytes on demand
UPDATE:  Positioning of components in Preferences dialog
         improved
UPDATE:  Turbo Blizzard plugin generates correct trp3
         tape image chunks
UPDATE:  Possibility to inverse polarity of pulses for
         KSO Turbo 2000 and Turbo Blizzard
UPDATE:  TapeImage plugin improved. Generated instructions
         are prefixed and suffixed with silence.
NEW:     All generators can now handle DATA instruction
         with zero data length (useful for Turbo Blizzard)
NEW:     Polish Turbo Blizzard added. Tested only using
         A8CAS extended emulator.
NEW:     Generator instruction INSTR_SETUP augmented
         to handle polarity of the pulses.
NEW:     New Generator instruction INSTR_BLOCKSEP that can
         be used to separate blocks using 1000 samples
         of silence. This allows Turbo Monitor to stop
         after each block and time is not wasted by usage
         of 0.25 sec silence after each block as it was
         implemented in previous versions.
UPDATE:  Various GUI improvements providing convenience,
         some confusing error messages were polished.
BUGFIX:  Tape image plugin worked badly when not at
         last position in plugin properties
INCOMP:  Due to new plugin identification, playlists
         and setup of pulses are incompatible with
         previous versions.


Changes from version 8.1.3 to 8.1.4
===================================
UPDATE:  Wizard for binary files reworked

UPDATE:  Panel for Turbo 2000 and Super Turbo playlist
         items reworked

Changes from version 8.1.2 to 8.1.3
====================================
NEW:     Turbo monitor decoder

UPDATE:  Turbo decoder settings completely reworked

UPDATE:  Built-in small loaders updated and reworked

UPDATE:  Generated turbo is more 'Turbo monitor friendly'.
         That represents short silence insertion between 
         blocks

REMOVED: MICROB built-in loader removed, because its
         distribution would be incompatible with GPL


Changes from version 8.1.0 to 8.1.2
====================================
UPDATE: Minimalistic updates (Error and warning messages),
        labels

UPDATE: Documentation updated


Changes from version 8.1.0 to 8.1.1
====================================

BUGFIX: Button that restore default settings
        of Turbo 2000 decoder also resets
        the 'Super Turbo style decoding' checkbox.

UPDATE: 'UniTurbo behaviour' label replaced by
        'Super Turbo style decoding'

BUGFIX: TURBO TAPE decoder improved much

UPDATE: Documentation fixes